<?php

namespace Drupal\fullcalendar_legend\Plugin\Block;

use Drupal\field\FieldStorageConfigInterface;

/**
 * Provides a block plugin to display the legend of a full calendar.
 *
 * @Block(
 *   id = "fullcalendar_legend_bundle",
 *   admin_label = @Translation("FullCalendar Legend"),
 *   category = @Translation("Fullcalendar")
 * )
 */
class Bundle extends FullcalendarLegendBase {

  /**
   * {@inheritdoc}
   */
  protected function buildLegend(array $fields): array {
    $types = [];

    $bundle_info = $this->entityTypeBundleInfo->getAllBundleInfo();

    foreach ($fields as $field_name => $field) {
      if ($field instanceof FieldStorageConfigInterface) {
        $entity_type = $field->getTargetEntityTypeId();
        foreach ($field->getBundles() as $bundle) {
          if (!isset($types[$bundle])) {
            $types[$bundle]['entity_type'] = $entity_type;
            $types[$bundle]['field_name'] = $field_name;
            $types[$bundle]['bundle'] = $bundle;
            $types[$bundle]['label'] = $bundle_info[$entity_type][$bundle]['label'];
          }
        }
      }
    }

    return $types;
  }

}
